glibmm 2.86.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gio::BytesIcon Class Reference

An icon stored in memory as a Glib::Bytes. More...

`#include <giomm/bytesicon.h>`

Inheritance diagram for Gio::BytesIcon:
[legend]

## Public Member Functions
| BytesIcon (BytesIcon && src) noexcept
BytesIcon & | operator= (BytesIcon && src) noexcept
| ~BytesIcon () noexcept override
GBytesIcon * | gobj ()
| Provides access to the underlying C GObject.
const GBytesIcon * | gobj () const
| Provides access to the underlying C GObject.
GBytesIcon * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Glib::RefPtr< const Glib::Bytes > | get_bytes () const
| Gets the Bytes associated with the given icon.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Glib::Bytes > > | property_bytes () const
| The bytes containing the icon.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object && src) noexcept
Object & | operator= (Object && src) noexcept
void * | get_data (const QueryQuark & key)
void | set_data (const Quark & key, void * data)
void | set_data_with_c_callback (const Quark & key, void * data, GDestroyNotify notify)
void | set_data (const Quark & key, void * data, DestroyNotify notify)
| Prefer set_data_with_c_callback() with a callback with C linkage.
void | remove_data (const QueryQuark & quark)
void * | steal_data (const QueryQuark & quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring & property_name, const Glib::ValueBase & value)
| You probably want to use a specific property_*() accessor method instead.
void | get_property_value (const Glib::ustring & property_name, Glib::ValueBase & value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType>
void | set_property (const Glib::ustring & property_name, const PropertyType & value)
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType>
void | get_property (const Glib::ustring & property_name, PropertyType & value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType>
PropertyType | get_property (const Glib::ustring & property_name) const
| You probably want to use a specific property_*() accessor method instead.
sigc::connection | connect_property_changed (const Glib::ustring & property_name, const sigc::slot< void()> & slot)
| You can use the signal_changed() signal of the property proxy instead.
sigc::connection | connect_property_changed (const Glib::ustring & property_name, sigc::slot< void()> && slot)
| You can use the signal_changed() signal of the property proxy instead.
void | freeze_notify ()
| Increases the freeze count on object.
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify().
virtual void | reference () const
| Increment the reference count for this object.
virtual void | unreference () const
| Decrement the reference count for this object.
GObject * | gobj ()
| Provides access to the underlying C GObject.
const GObject * | gobj () const
| Provides access to the underlying C GObject.
GObject * | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access.
Public Member Functions inherited from Gio::Icon
| Icon (Icon && src) noexcept
Icon & | operator= (Icon && src) noexcept
| ~Icon () noexcept override
GIcon * | gobj ()
| Provides access to the underlying C GObject.
const GIcon * | gobj () const
| Provides access to the underlying C GObject.
guint | hash () const
| Gets a hash for an icon.
std::string | to_string () const
| Generates a textual representation of icon that can be used for serialization such as when passing icon to a different process or saving it to persistent storage.
bool | equal (const Glib::RefPtr< Icon > & other) const
Glib::VariantBase | serialize () const
| Serializes a Icon into a Variant.
Public Member Functions inherited from Glib::Interface
| Interface ()
| A Default constructor.
| Interface (Interface && src) noexcept
Interface & | operator= (Interface && src) noexcept
| Interface (const Glib::Interface_Class & interface_class)
| Called by constructors of derived classes.
| Interface (GObject * castitem)
| Called by constructors of derived classes.
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Gio::LoadableIcon
| LoadableIcon (LoadableIcon && src) noexcept
LoadableIcon & | operator= (LoadableIcon && src) noexcept
| ~LoadableIcon () noexcept override
GLoadableIcon * | gobj ()
| Provides access to the underlying C GObject.
const GLoadableIcon * | gobj () const
| Provides access to the underlying C GObject.
Glib::RefPtr< InputStream > | load (int size, Glib::ustring & type, const Glib::RefPtr< Cancellable > & cancellable)
| Loads a loadable icon.
Glib::RefPtr< InputStream > | load (int size, Glib::ustring & type)
| Non-cancellable version of load().
void | load_async (int size, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable)
| Loads an icon asynchronously.
void | load_async (int size, const SlotAsyncReady & slot)
| Non-cancellable version of load_async().

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< BytesIcon > | create (const Glib::RefPtr< const Glib::Bytes > & bytes)
| Creates a new icon for a Glib::Bytes.
Static Public Member Functions inherited from Gio::Icon
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< Icon > | create (const std::string & str)
| Generate an Icon instance from str.
static Glib::RefPtr< Icon > | deserialize (const Glib::VariantBase & value)
| Deserializes a Icon previously serialized using g_icon_serialize().
Static Public Member Functions inherited from Gio::LoadableIcon
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Protected Member Functions
| BytesIcon (const Glib::RefPtr< const Glib::Bytes > & bytes)
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams & construct_params)
| Object (GObject * castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor.
| ObjectBase (const char * custom_type_name)
| A derived constructor always overrides this choice.
| ObjectBase (const std::type_info & custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually.
| ObjectBase (ObjectBase && src) noexcept
ObjectBase & | operator= (ObjectBase && src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject * castitem)
void | initialize_move (GObject * castitem, Glib::ObjectBase * previous_wrapper)
Protected Member Functions inherited from Gio::Icon
| Icon ()
| You should derive from this class to use it.
Protected Member Functions inherited from Gio::LoadableIcon
| LoadableIcon ()
| You should derive from this class to use it.

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gio::BytesIcon > | wrap (GBytesIcon * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject * object, bool take_copy=false)
Related Symbols inherited from Gio::Icon
Glib::RefPtr< Gio::Icon > | wrap (GIcon * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gio::LoadableIcon
Glib::RefPtr< Gio::LoadableIcon > | wrap (GLoadableIcon * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from Glib::Object
using | DestroyNotify = void (*)(gpointer data)

## Detailed Description

An icon stored in memory as a Glib::Bytes.

Gio::BytesIcon specifies an image held in memory in a common format (usually png) to be used as icon.

See also
  Icon, LoadableIcon, Glib::Bytes

Since glibmm 2.76

## Constructor & Destructor Documentation

## ◆ BytesIcon() [1/2]

Gio::BytesIcon::BytesIcon | ( | BytesIcon && | src | ) |
| noexcept

## ◆ ~BytesIcon()

Gio::BytesIcon::~BytesIcon | ( |  | ) |
| override noexcept

## ◆ BytesIcon() [2/2]

Gio::BytesIcon::BytesIcon | ( | const Glib::RefPtr< const Glib::Bytes > & | bytes | ) |
| explicit protected

## Member Function Documentation

## ◆ create()

Glib::RefPtr< BytesIcon > Gio::BytesIcon::create | ( | const Glib::RefPtr< const Glib::Bytes > & | bytes | ) |
| static

Creates a new icon for a Glib::Bytes.

This cannot fail, but loading and interpreting the bytes may fail later on (for example, if Gio::LoadableIcon::load() is called) if the image is invalid.

Since glibmm 2.76

Parameters

  bytes | A Glib::Bytes.

Returns
  A Icon for the given bytes.

## ◆ get_bytes()

Glib::RefPtr< const Glib::Bytes > Gio::BytesIcon::get_bytes | ( |  | ) | const

Gets the Bytes associated with the given icon.

Since glibmm 2.76

Returns
  A Bytes.

## ◆ get_type()

GType Gio::BytesIcon::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GBytesIcon * Gio::BytesIcon::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GBytesIcon * Gio::BytesIcon::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GBytesIcon * Gio::BytesIcon::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

BytesIcon & Gio::BytesIcon::operator= | ( | BytesIcon && | src | ) |
| noexcept

## ◆ property_bytes()

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Glib::Bytes > > Gio::BytesIcon::property_bytes | ( |  | ) | const

The bytes containing the icon.

Since glibmm 2.76

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gio::BytesIcon > wrap | ( | GBytesIcon * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.